'TEXT2PDF.BAS
'coded with pbwin 10.04 compiler
'create a pdf file from text only files
'code uses Haru Free PDF Library 2.0.0
'Jose Roca coded the Haru include files
'Made minor changes to variables that Jose Roca used, mostly remove underline characters


#COMPILE EXE
#DIM ALL
%UNICODE=1
#INCLUDE ONCE "windows.inc"
#INCLUDE ONCE "hpdf.inc"
#INCLUDE ONCE "grid_sheet.inc"

GLOBAL gspdffileoutput AS STRING
GLOBAL gstextfilestoread() AS STRING
GLOBAL gipdfpageorientation AS LONG
GLOBAL gimaxcharacterwidth AS LONG
GLOBAL gstextfilecontents() AS STRING
GLOBAL giprintgridoverlay AS LONG
GLOBAL gierror AS LONG  'global error in program
GLOBAL giverbose AS LONG 'display error messages
GLOBAL gitabspaces AS LONG ' number of spaces to replace a tab character with


' ========================================================================================
' Callback error handler procedure
' ========================================================================================
SUB HPDF_Error_Handler HPDF_CALLCONV ( _
   BYVAL error_no AS HPDF_STATUS, _
   BYVAL detail_no AS HPDF_STATUS, _
   BYVAL user_data AS DWORD)
   LOCAL strMsg AS STRING
   strMsg = "Error number = " & STR$(error_no) & " [&H" & HEX$(error_no) & "]" & $CRLF
   strMsg = strMsg & "Detail number = " & STR$(detail_no) & " [&H" & HEX$(detail_no) & "]"
   gierror=1
   IF giverbose=1 THEN MSGBOX  "pdf file create error "+$CRLF+strMsg,,EXE.NAME$

END SUB
' ========================================================================================


'function to read the command line and set variables in
'string array gstextfilestoread is for text files to be read in
'gspdfileoutput is name of pdf file wanted to create
'gipdfpageorientation is pdf page orientation desired for each text file
'giprintgridoverlay flag to print a grid on each page in the pdf
FUNCTION readcommandline() AS LONG
   DIM i AS LONG, j AS LONG
      DIM icount AS LONG
   DIM ifiletoreadcount AS LONG
   DIM scommand() AS STRING
   DIM itabspaces AS LONG
   itabspaces=0
   'set default orientation of pdf file
   gipdfpageorientation=0 'auto orientation
   FUNCTION=1  'exit function with no errors
   WHILE -1
        INCR i
        IF LEN(COMMAND$(i))>0 THEN
           INCR icount
           ELSE
           EXIT
      END IF
   WEND
   IF icount<2 THEN FUNCTION=0:EXIT FUNCTION
   REDIM scommand(1 TO icount)
   FOR i=1 TO icount
      scommand(i)=TRIM$(COMMAND$(i))
      'command line option to set the name of the pdf file to create
      IF LEN(scommand(i))>4 THEN
         IF UCASE$(RIGHT$(scommand(i),4))=".PDF" THEN
            gspdffileoutput=scommand(i)
            scommand(i)=""
            ITERATE
         END IF
      END IF
      'command line option to set pdf page orientation, automatic is the default
      IF LEFT$(scommand(i),1)="/" THEN
          IF LEN(scommand(i))>1 THEN
             'command line option to print grid overlay
             IF LEFT$(UCASE$(scommand(i)),2)="/G" THEN giprintgridoverlay=1:scommand(i)="":ITERATE
             'command line option to produce no messages
             IF LEFT$(UCASE$(scommand(i)),2)="/V" THEN giverbose=1:scommand(i)="":ITERATE
             'command line option to set all pdf pages to portrait orientation
             IF LEFT$(UCASE$(scommand(i)),2)="/P" THEN gipdfpageorientation=1:scommand(i)="":ITERATE
             'command line option to set all pdf pages to landscape orientation
             IF LEFT$(UCASE$(scommand(i)),2)="/L" THEN gipdfpageorientation=2:scommand(i)="":ITERATE
            'command line option to set all pdf pages to automatic orientation
             IF LEFT$(UCASE$(scommand(i)),2)="/A" THEN gipdfpageorientation=3:scommand(i)="":ITERATE
            'command line option to set number of spaces per tab
             IF LEFT$(UCASE$(scommand(i)),2)="/T" THEN
                 itabspaces=VAL(RIGHT$(scommand(i),LEN(scommand(i))-2))
                 IF itabspaces>0 THEN gitabspaces=itabspaces
                 scommand(i)="":ITERATE
             END IF
            'command line option to get help
             IF LEFT$(UCASE$(scommand(i)),2)="/?" THEN FUNCTION=0:EXIT FUNCTION
         END IF
      END IF
    'all other command line options should be text input files to read
    'any confirmation of the existance of a text file will be done in the readfilecontents function
    IF ISFILE (scommand(i)) THEN INCR ifiletoreadcount ELSE scommand(i)=""
   NEXT i
   IF LEN(gspdffileoutput)=0 OR ifiletoreadcount=0 THEN FUNCTION=0:EXIT FUNCTION
   REDIM gstextfilestoread(1 TO ifiletoreadcount)
   j=0
   FOR i=1 TO icount
       IF LEN(scommand(i))> 0 THEN
           INCR j
           gstextfilestoread(j)=scommand(i)
       END IF
   NEXT i
END FUNCTION

'this function will read a file
'break all text lines into a string array named gstextfilecontents
'split lines with any formfeed characters and place the formfeed characters in their own lines
'count the maximum line width in the text file and set gimaxcharacterwidth
'tabs will be replaced with 8 space characters
FUNCTION readfilecontents(BYVAL sfilename AS STRING) AS LONG
   DIM i AS LONG
   DIM j AS LONG
   DIM icountff AS LONG
   DIM icount AS LONG
   DIM itempcount AS LONG
   DIM stemp1 AS STRING
   DIM stemp2 AS STRING
   DIM stemp3 AS STRING
   DIM stabreplacement AS STRING
   DIM sfilecontents() AS STRING

   gimaxcharacterwidth=0
   FUNCTION=1
   DIM gstextfilecontents (1 TO 1):gstextfilecontents(1)=""
   IF NOT ISFILE (sfilename) THEN FUNCTION=0:EXIT FUNCTION
   TRY
      OPEN sfilename FOR INPUT AS #1
   CATCH
      MSGBOX "Cannot read the file "+sfilename,,EXE.NAME$
      gierror=1
      CLOSE #1
      FUNCTION=0
      EXIT FUNCTION
   EXIT TRY
   FINALLY
        FILESCAN #1, RECORDS TO icount
        IF icount=0 THEN CLOSE #1:FUNCTION=0:EXIT FUNCTION
        REDIM sfilecontents(1 TO icount)
        LINE INPUT #1, sfilecontents() TO icount
        CLOSE #1
   END TRY

   stabreplacement=STRING$(gitabspaces,$SPC)
      itempcount=0
   FOR i=1 TO icount
      INCR itempcount
      icountff=TALLY(sfilecontents(i),$FF)
      IF icountff THEN itempcount=itempcount+icountff+1
   NEXT i
  REDIM  gstextfilecontents(1 TO itempcount)
  itempcount=0
  FOR i=1 TO UBOUND(sfilecontents)
     stemp3=RTRIM$(sfilecontents(i))
        WHILE -1
           IF INSTR(stemp3,$TAB) THEN
              REPLACE $TAB WITH stabreplacement IN stemp3
              ITERATE
              ELSE
              EXIT
           END IF
        WEND
     stemp3=RTRIM$(stemp3)

     IF INSTR(stemp3,$FF)=0 THEN
        INCR itempcount
        gstextfilecontents(itempcount)=stemp3
        ITERATE
     END IF
     stemp1=""
     stemp2=""
     FOR j=1 TO LEN(stemp3)
          stemp1=MID$(stemp3,j,1)
          IF stemp1<>$FF THEN  stemp2=stemp2+stemp1:ITERATE
          IF LEN(stemp2)>0 THEN
              INCR itempcount
              gstextfilecontents(itempcount)=RTRIM$(stemp2)
              stemp2=""
          END IF
          INCR itempcount
          gstextfilecontents(itempcount)=stemp1
    NEXT j
    IF LEN(stemp2)>0 THEN
       INCR itempcount
       gstextfilecontents(itempcount)=RTRIM$(stemp2)
       stemp2=""
    END IF
    NEXT i
    ERASE sfilecontents()
    REDIM PRESERVE gstextfilecontents(1 TO itempcount)
    FOR i=1 TO UBOUND(gstextfilecontents)
       IF LEN(gstextfilecontents(i))> gimaxcharacterwidth THEN gimaxcharacterwidth=LEN(gstextfilecontents(i))
   NEXT i
   IF gimaxcharacterwidth=0 THEN
      FUNCTION=0
      ELSE
      FUNCTION=1
   END IF
 END FUNCTION


FUNCTION createpdf() AS LONG
   LOCAL pdf AS HPDF_Doc
   LOCAL zspdffilename AS ASCIIZ * 256
   LOCAL hPage AS HPDF_Page
   LOCAL embed AS HPDF_BOOL
   LOCAL deffont AS HPDF_Font
   LOCAL usefont AS HPDF_Font
   LOCAL detail_font AS HPDF_Font
   LOCAL nHeight AS HPDF_REAL
   LOCAL nWidth AS HPDF_REAL
   LOCAL hFont AS HPDF_Font
   LOCAL detailfont AS HPDF_Font
   LOCAL pv AS DWORD
   LOCAL pdetailfontname AS ASCIIZ PTR
   LOCAL ibaseheight AS LONG
   LOCAL ibasewidth AS LONG
   LOCAL iorientation  AS LONG
   LOCAL ipapertype AS LONG
   LOCAL ilinespacing AS LONG
   LOCAL sfontsfolder AS STRING
   LOCAL sfonttemp AS STRING
   LOCAL zsfontname AS ASCIIZ * 256
   LOCAL zsdetailfontname AS ASCIIZ * 256
   LOCAL sdetailfontname AS STRING
   LOCAL i AS LONG
   LOCAL j AS LONG
   LOCAL k AS LONG
   LOCAL icurrentline AS LONG
   LOCAL ilinesinfile AS LONG
   LOCAL ipdflinecount AS LONG
   LOCAL sline AS STRING
   LOCAL iresult AS LONG
   LOCAL ifontsize AS LONG
   LOCAL zslinefromfile AS ASCIIZ * 256

   FUNCTION=0
   zspdffilename = gspdffileoutput
   KILL gspdffileoutput

   pdf = HPDF_New(CODEPTR(HPDF_Error_Handler), %NULL)
   IF pdf = %NULL THEN
      KILL gspdffileoutput
      gierror=1
      IF giverbose=1 THEN MSGBOX  "Error: cannot create PdfDoc object",,EXE.NAME$
      EXIT FUNCTION
   END IF
     ' /* set compression mode */
   HPDF_SetCompressionMode (pdf, %HPDF_COMP_ALL)

   zsfontname="Courier"
   deffont = HPDF_GetFont (pdf, zsfontname, BYVAL %NULL)
   sfontsfolder=ENVIRON$("systemroot")+"\fonts"
   sdetailfontname=""
   IF sdetailfontname="" THEN
      sfonttemp=sfontsfolder+"\lucon.ttf"                  ' Lucida Console ttf font
      IF ISFILE (sfonttemp) THEN sdetailfontname=sfonttemp
   END IF
   IF sdetailfontname="" THEN
      sfonttemp=sfontsfolder+"\cour.ttf"                   'Courier New ttf font
      IF ISFILE (sfonttemp) THEN sdetailfontname=sfonttemp
   END IF
   IF sdetailfontname="" THEN
      usefont=deffont
      ELSE
      zsdetailfontname=sdetailfontname
      embed = %HPDF_TRUE
      pv = HPDF_LoadTTFontFromFile (pdf, zsdetailfontname, embed)
      pdetailfontname = pv
      detailfont = HPDF_GetFont (pdf, @pdetailfontname, BYVAL %NULL)
      usefont=detailfont
    END IF

'read each file and place in a single pdf file
FOR k=1 TO UBOUND(gstextfilestoread)
   iresult=readfilecontents(gstextfilestoread(k))
   IF iresult=0 OR gimaxcharacterwidth=0 THEN GOTO DOTHENEXTTEXTFILE
   'ipapertype 0=letter 1=legal
   ipapertype=0
   'orientation 0=portrait 1=landscape
   iorientation=0
   IF gipdfpageorientation=0 THEN gipdfpageorientation=3
   IF gipdfpageorientation=1 THEN  iorientation=0
   IF gipdfpageorientation=2 THEN  iorientation=1
   IF gipdfpageorientation=3 THEN
      IF gimaxcharacterwidth<87 THEN iorientation=0
      IF gimaxcharacterwidth>86 THEN iorientation=1
   END IF

   IF iorientation=0 THEN
      IF gimaxcharacterwidth<87 THEN ifontsize=10 ELSE ifontsize=7
      ilinespacing=-11
   END IF
   IF iorientation<>0 THEN
      ifontsize=9
      ilinespacing=-8
   END IF

   icurrentline=0
   ipdflinecount=0
   ilinesinfile=UBOUND(gstextfilecontents)
   WHILE -1
      INCR icurrentline
      IF icurrentline>ilinesinfile THEN EXIT
      IF ilinesinfile=icurrentline AND gstextfilecontents(icurrentline)=$FF THEN EXIT
      IF gstextfilecontents(icurrentline)=$FF THEN ipdflinecount=0:INCR icurrentline
      IF ipdflinecount=0 THEN
         ' /* Add a new page object. */
         hPage = HPDF_AddPage (pdf)
         HPDF_Page_SetSize (hPage, ipapertype, iorientation)
         IF giprintgridoverlay THEN print_grid  (pdf, hPage)
         nHeight = HPDF_Page_GetHeight (hPage)
         nWidth = HPDF_Page_GetWidth (hPage)
         ibaseheight=nheight
         ibasewidth=nwidth
         HPDF_Page_SetFontAndSize (hPage, usefont, ifontsize)
         HPDF_Page_BeginText (hPage)
         HPDF_Page_MoveTextPos (hPage, 27, ibaseheight)
         HPDF_Page_MoveTextPos (hPage, 0, -45)
      END IF
      IF ilinesinfile<icurrentline THEN EXIT
      zslinefromfile=gstextfilecontents(icurrentline)
      HPDF_Page_ShowText (hPage, zslinefromfile)
      INCR ipdflinecount
      IF ipdflinecount>66 THEN
         ipdflinecount=0
         ELSE
         HPDF_Page_MoveTextPos (hPage, 0, ilinespacing)
      END IF
   WEND
DOTHENEXTTEXTFILE:
NEXT k
   HPDF_Page_EndText (hPage)
   HPDF_SaveToFile (pdf, zspdffilename)
   ' /* clean up */
   HPDF_Free (pdf)
FUNCTION=1
END FUNCTION


FUNCTION PBMAIN
DIM iresult AS LONG
FUNCTION=1
gitabspaces=5
gierror=0
iresult=readcommandline
IF iresult=0  THEN
    FUNCTION=1
    MSGBOX "A bad command tail was given."+$CRLF+_
    "This program makes use of the Haru Free PDF Library 2.0.2."+$CRLF+_
    "Copyright (c) 1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp"+$CRLF+_
    "Files also need are libhpdf.dll,libpng13.dll,zlib.dll"+$CRLF+_
    "Haru is provided as is without express or implied warranty."+$CRLF+_
    "All users of this software take full total and all risk in using this software."+$CRLF+_
    "Place any number of existing text only files on the command tail."+$CRLF+_
    "The users is responsible to make sure files are text only."+$CRLF+_
    "Form feed characters inside the files will create a page break."+$CRLF+_
    "Tabs will be replaced with 5 space characters in each line."+$CRLF+_
    "Number of spaces for tab replacement can be overridden with the  option /t## ."+$CRLF+_
    "Any files that do not exist will be skipped over."+$CRLF+_
    "Files are read in the order placed on the comman tail."+$CRLF+_
    "Place a file name with a pdf file extension to create."+$CRLF+_
    "If more than one pdf filename is given, then the last filename is used."+$CRLF+_
    "The pdf filename can be anywhere on the command line."+$CRLF+_
    "An existing pdf file will be deleted first then created."+$CRLF+_
    "Fixed fonts are either, TTF Lucida Console, TTF Courier New, or build in Courier."+$CRLF+_
    "The orientation of pdf pages will be set depending on the"+$CRLF+_
    "   maximum number of characters wide in each separate text file read."+$CRLF+_
    "Orientation of all pdf pages in the pdf file can be overridden."+$CRLF+_
    "There are three global setting for orientation (Automatic, Portait, or Landscape)."+$CRLF+_
    "Automatic pdf page layout is the default and using /A /P or /L will override."+$CRLF+_
    "In automatic layout, landscape is selected for files having lines more than 86 characters."+$CRLF+$CRLF+_
    "Example:  program file1.txt file2.txt test1.pdf /p file3.txt file4.txt test2.pdf file5.txt"+$CRLF+_
    "This will produce a pdf file named test2.pdf with all portrait orientated pages."+$CRLF+_
    "Test1.pdf is not used because test2.pdf is the last filename ending with .pdf ." +$CRLF+_
    "Commnad tail option /grid will print a grid sheet overlay to each pdf page."+$CRLF+_
    "Command tail option /verbose will cause the program to generate messages on errors.",, EXE.NAME$
     EXIT FUNCTION
END IF

iresult=createpdf
IF iresult<> 1 THEN FUNCTION=0
IF gierror=1 THEN FUNCTION=1

'RETURN function=0 IF
END FUNCTION
' ========================================================================================
